//
//  ViewController.swift
//  CD10-Multithreading
//
//  Created by bulko on 3/24/25.
//

import UIKit

class ViewController: UIViewController {
    
    var queue: DispatchQueue!
    var dot: UIView!
    var xLeft: Double!
    var xRight: Double!
    var y: Double!

    override func viewDidLoad() {
        super.viewDidLoad()
        
        let dotHeight = 100.0
        let dotWidth = 100.0
        
        xLeft = dotWidth/2.0
        xRight = self.view.bounds.width - 1.5 * dotWidth
        y = (self.view.bounds.height/2.0) - (dotHeight/2.0)
        
        dot = UIView(frame: CGRect(
            x: xLeft,
            y: y,
            width: dotWidth,
            height: dotHeight))
        dot.backgroundColor = .red
        
        dot.layer.cornerRadius = dotWidth/2.0
        
        self.view.addSubview(dot)
        
        queue = DispatchQueue(label: "myQueue", qos:.utility)
        
        queue.async {
            self.moveBlock()
        }
    }

    func moveBlock() {
        
        var toggle = "left"
        
        while true {
            
            usleep(300000)   // sleep for 0.3 seconds
            
            if toggle == "left" {
                toggle = "right"
                DispatchQueue.main.async {
                    self.dot.frame.origin.x = self.xRight
                }
            } else {
                toggle = "left"
                DispatchQueue.main.async {
                    self.dot.frame.origin.x = self.xLeft
                }
            }
            
        }
        
    }

}

